#include <irrlicht/irrlicht.h>
#include "mods.h"

using namespace irr;
using namespace core;
using namespace video;
using namespace gui;

int main()
{
  load_mods();

  IrrlichtDevice* device =
    createDevice(EDT_OPENGL,
                 dimension2d<u32>(640, 480), 16,
                 false, false, false, 0);
  if (!device)
    return 1;

  device->setWindowCaption(L"Dungeon Master");

  IVideoDriver* driver = device->getVideoDriver();
  IGUIEnvironment* env = device->getGUIEnvironment();

  env->addStaticText(L"Dungeon Master", rect<s32>(150,20,350,40), true);

  IGUITabControl* tab = env->addTabControl(rect<s32>(50, 60, 850, 600));
  tab->addTab(L"First");
  tab->addTab(L"Second");
  tab->addTab(L"Third");

  while (device->run())
    {
      driver->beginScene(true, true, SColor(0, 200, 200, 200));
      env->drawAll();
      driver->endScene();
    }

  device->drop();

  return 0;
}
